//
// 
import javafx.geometry.Pos;
import javafx.scene.control.Label;
import javafx.scene.control.ListCell;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.VBox;
import javafx.scene.text.TextAlignment;

public class ImageTextCell extends ListCell<Book>
{
   @Override 
   protected void updateItem(Book item, boolean empty) {
      // call ListCell version of updateItem
      super.updateItem(item, empty);

      if (item == null)
      {
         setGraphic(null);
      }
      else 
      {
         VBox vbox = new VBox(8.0); // cell's layout
         vbox.setAlignment(Pos.CENTER); // center contents horizontally
         
         // configure thumb image
         ImageView thumbImageView = 
            new ImageView(new Image(item.getThumbImage()));
         thumbImageView.setPreserveRatio(true);
         thumbImageView.setFitHeight(100.0); // thumb 100 points tall
         vbox.getChildren().add(thumbImageView);
         
         // configure text
         Label label = new Label(item.getTitle());
         label.setWrapText(true);
         label.setTextAlignment(TextAlignment.CENTER);
         vbox.getChildren().add(label);
         
         setGraphic(vbox); // attach custom layout to ListView cell
         setPrefWidth(USE_PREF_SIZE); // use preferred size based on parent
      }
   }
}
